<?

ini_set("soap.wsdl_cache_enabled", "0"); 

function solve($query)
{
	global $server;
	$sol=$server->solve($query);
	$n=$sol->getCount();
	$a=array();
	for ($i=0;$i<$n;$i++) {
		$hit=$sol->getHit($i);
		$text=$hit->getText(0,100);
		$ha=array("text"=>$text,"doc"=>$hit->getCorpusText()->getTitle(),"unit"=>$hit->getUnit());
		$a[$i]=$ha;
	}
	return $a;
}

function getWordList($pattern)
{
	global $server;
	$l=$server->getWordList($pattern);
	$n=$l->getCount();
	$a=array();
	for ($i=0;$i<$n;$i++) {
		$w=$l->getWord($i);
		$wa=array("norm"=>$w->getNorm(0),"frequency"=>$w->getFrequency());
		$a[$i]=$wa;
	}
	return $a;
}

function getFormList($pattern)  
{
	global $server;
	$n=0;
	$wl=$server->getWordList($pattern);
	if ($wl) $n=$wl->getCount();
	$f=array();
	if ($n==0) return $f;
	$w=$wl->getWord(0);
	$m=$w->getFormCount();
	$g=$server->getGrammar();
	$na=$g->getAddkeyCount();
	for ($i=0;$i<$m;$i++) {
		$fo=$w->getForm($i);
		$fa=array("norm"=>$fo->getNorm(),"frequency"=>$fo->getFrequency());
		for ($j=0;$j<$na;$j++) {
			$ak=$g->getAddkey($j);
			if ($ak->isLemmaScheme()) continue;
			$fa[$ak->getName()]=$fo->getAdditionalKey($ak->getName());
		}
		$f[$i]=$fa;
	}
	return $f;
}

function collocation($w, $m, $wl, $wr)  
{
	global $server;
	$c=array();
	$sol=NULL;
	$n=0;
	$sol=$server->solve($w);
	if ($sol==NULL) return $c;
	$t=$sol->makeCollocationTable(".*","",$m,array("wl"=>$wl,"wr"=>$wr),1000,-1000.0,1000.0,0);
	$n=$t->getCount();
	for ($i=0;$i<$n;$i++) {
		$coll=$t->getCollocate($i);
		$c[$i]=array("word"=>$coll->getWord()->getNorm(0),"hits"=>$coll->getHits(),"frequency"=>$coll->getWord()->Freq(),"score"=>$coll->getScore());
	}
	return $c;
}

	
$soap_server=new SoapServer("Xaira.wsdl",array("encoding"=>"UTF-8"));
$server=XairaServer::getXairaServer();
$soap_server->addFunction("getWordList");
$soap_server->addFunction("getFormList");
$soap_server->addFunction("solve");
$soap_server->addFunction("collocation");
$soap_server->handle();

?>

